### Method

# FwupdPlugin Device write_firmware

#### Declaration [src]

    gboolean
    fu_device_write_firmware (
      FuDevice* self,
      FuFirmware* firmware,
      FuProgress* progress,
      FwupdInstallFlags flags,
      GError** error
    )

#### Description [src]

Writes firmware to the device by calling a plugin-specific vfunc.

Available since: | 2.0.7

#### Parameters

`firmware` | `FuFirmware`
| A `FuFirmware`.
| The data is owned by the caller of the function.
`progress` | `FuProgress`
| A `FuProgress`.
| The data is owned by the caller of the function.
`flags` | `FwupdInstallFlags`
| Install flags, e.g. `FWUPD_INSTALL_FLAG_FORCE`.
`error` | `GError **`
| The return location for a `GError*`, or `NULL`.

#### Return value

Returns: | `gboolean`
| `TRUE` on success.